%%% Tait_Martin-Löf proof of Church-Rosser using parallel reduction
%%
%%% Stephan Scheele, Alberto Momigliano :: Dec. 2012
% 
%% This proof shows confluence for the (monomodal fragment of) lambda-CKn for closed terms.
%% Commuting conversions are omitted.
%% This work extends the work by Accatolli who gave a Abella proof of confluence for the simple lambda calculus.
%% We extend the lambda calculus by products, sums and contextual terms and reductions.

sig crcknV2.

kind     tm                type.
kind     sc                type.

type     app               tm -> tm -> tm.
type     abs               (tm -> tm) -> tm.

% products and sums
type     pair              tm -> tm -> tm.
type     fst               tm -> tm.
type     snd               tm -> tm.

type      case              tm -> (tm -> tm) -> (tm -> tm) -> tm.
type      inl               tm -> tm.
type      inr               tm -> tm.


% contextual types 
%% diamond
type     let               tm -> (sc -> tm -> tm) -> tm.
type     dia               sc -> tm -> tm.      
%% box
type     box               (sc -> tm) -> tm.
type     atw               sc -> tm -> tm.


